/*************************************************************************************************
ܣ12864ʾ򣬿KS0108
ߣ½ 
http://list.taobao.com/browse/search_auction.htm?user=2350bd79829fce7adeae06967a782b28&commend=all
*************************************************************************************************/

#include <reg51.h>

/********************************
궨
********************************/
#define uchar unsigned char
#define uint  unsigned int
#define Left  (0)
#define Right (1)

/********************************
I/Oڶ壬ͬʱڴ޸
********************************/
#define LCD_PORT P3
sbit    lcd_busy_flag = LCD_PORT^7;
sbit    RS  = P2^3;
sbit    RW  = P2^4;
sbit    E   = P2^2;
sbit    CS0 = P2^7;
sbit    CS1 = P2^6;
sbit    RST = P2^5;

uchar code hanzi1[32]={0x84,0x10,0x84,0x14,0xA4,0x14,0xA4,0x14,0xE4,0x17,0xBF,0x14,0xA4,0x14,0xE4,0xFF,
                       0xA4,0x14,0xBF,0x14,0xE4,0x17,0xA4,0x14,0xA4,0x14,0xA4,0x14,0x84,0x10,0x00,0x00};
uchar code hanzi2[32]={0x08,0x00,0xA8,0x7E,0xA9,0x22,0xAE,0x22,0xAA,0x22,0xA8,0x7E,0x02,0x00,0x42,0x00,
                       0x42,0x00,0xFE,0xFF,0x42,0x00,0x42,0x00,0xFE,0x1F,0x00,0x20,0x00,0x78,0x00,0x00};
uchar code hanzi3[32]={0x00,0x00,0x0C,0x00,0x04,0x00,0x55,0x1F,0x55,0x15,0x55,0x15,0x05,0x15,0x7F,0x7F,
                       0x05,0x95,0x55,0x95,0x55,0x95,0x55,0x9F,0x05,0x80,0x0C,0x80,0x04,0xF0,0x00,0x00};
uchar code hanzi4[32]={0x00,0x01,0x00,0x01,0x02,0x01,0x02,0x01,0x02,0x01,0x02,0x41,0x02,0x81,0xE2,0x7F,
                       0x12,0x01,0x0A,0x01,0x06,0x01,0x02,0x01,0x00,0x01,0x80,0x01,0x00,0x01,0x00,0x00};
uchar code hanzi5[32]={0x02,0x02,0x3A,0x01,0xEF,0xFF,0xBA,0x4A,0xC2,0x7F,0xBA,0x4A,0xAF,0x4A,0xBA,0xCA,
                       0x22,0x60,0x18,0x18,0xCF,0x07,0x08,0x18,0x28,0x20,0x18,0xC0,0x08,0x40,0x00,0x00};
uchar code hanzi6[32]={0x40,0x40,0x41,0x20,0xCE,0x1F,0x04,0x20,0x00,0x40,0xFC,0x47,0x04,0x42,0x02,0x41,
                       0x02,0x40,0xFC,0x5F,0x04,0x40,0x04,0x42,0x04,0x44,0xFC,0x43,0x00,0x40,0x00,0x00};
uchar code hanzi7[32]={0x00,0x00,0x40,0x80,0x42,0x40,0x44,0x20,0x5C,0x18,0xC8,0x07,0x40,0x00,0x7F,0x00,
                       0x40,0x00,0xC0,0x3F,0x50,0x40,0x4E,0x40,0x44,0x40,0x60,0x40,0x40,0x78,0x00,0x00};
uchar code hanzi8[32]={0x00,0x00,0xFC,0x7F,0x24,0x42,0x3C,0x7E,0x24,0x42,0xE4,0x43,0x14,0x00,0x0C,0x7E,
                       0xF7,0x22,0x94,0x7E,0x94,0x00,0x94,0x7E,0xF4,0x22,0x04,0x22,0x04,0x7E,0x00,0x00};
/********************************
ʱ
********************************/
void delay(uint t)
{
  uchar i;
  for(; t > 0; t--)
   {
    for(i = 0; i < 121; i++)
	 {
	  ;
	  }
    } 
 }

/********************************
æ
********************************/
void lcd_is_busy(void)
{
 /*
  E  = 0;
  RW = 1;
  RS = 0;
  E  = 1;
  LCD_PORT = 0xff;
  while(lcd_busy_flag);
 */
   unsigned char i;
 for(i=0x08;i>0;i--);
 
 }

/********************************
ѡҰ
********************************/
void select_screen(uchar s)	
{
  switch (s)
    {
	  case Left:   CS1 = 1;
                   CS0 = 0;
    			   break;
	  case Right:  CS0 = 1;
	               CS1 = 0;
				   break;
	  default: break;
	 }
  }

/********************************
д
********************************/
void lcd_write_command(uchar c)
{
  lcd_is_busy();
  E  = 1;
  RW = 0;
  RS = 0;
  LCD_PORT = c;
  E  = 0;
 }

/********************************
д
********************************/
void lcd_write_data(uchar d)
{
  lcd_is_busy();
  E  = 1;
  RW = 0;
  RS = 1;
  LCD_PORT = d;
  E  = 0;
 }

/********************************

********************************/
void lcd_clr(void)
{
  uchar i,j;
  //
  select_screen(Left);
  for(i = 0;i < 8;i ++)
  {
   lcd_write_command(0xB8+i);
   lcd_write_command(0x40);
   for(j = 0;j < 64;j ++)
    {
	  lcd_write_data(0x00);
	 }
   }
  //
  select_screen(Right);
  for(i = 0;i < 8;i ++)
  {
   lcd_write_command(0xB8+i);
   lcd_write_command(0x40);
   for(j = 0;j < 64;j ++)
    {
	  lcd_write_data(0x00);
	 }
   }
 }


/********************************
ַָдһ1616ĺ
********************************/
void lcd_print_hz16(uchar x,uchar y,uchar *zimo)
{
  uchar i;
  if(y >= 64)
   {
     select_screen(Right);
	 y-=64;
	}
  else
   {
     select_screen(Left);
	}
  lcd_write_command(x|0xB8);
  lcd_write_command(y|0x40);
  for(i = 0;i < 16; i ++)
    {
	  lcd_write_data(*(zimo+(i*2)));
	 }
  lcd_write_command((x|0xB8)+1);
  lcd_write_command(y|0x40);  
  for(i = 0;i < 16; i ++)
    {
	  lcd_write_data(*(zimo+(i*2)+1));
	 }
 }

/********************************
ʼ
********************************/
void lcd_initial(void)
{ 
  RST = 0;
  delay(10);
  RST = 1;
  select_screen(0);
  lcd_write_command(0xc0);
  lcd_write_command(0x3f);
  select_screen(1);
  lcd_write_command(0xc0);
  lcd_write_command(0x3f);
  CS0=1;
  CS1=1;
 }

/********************************

********************************/
void main()
{
  lcd_initial();
  lcd_clr();
  lcd_print_hz16(4,32,hanzi1);
  lcd_print_hz16(4,48,hanzi2);
  lcd_print_hz16(4,64,hanzi3);
  lcd_print_hz16(4,80,hanzi4);
  lcd_print_hz16(2,32,hanzi5);
  lcd_print_hz16(2,48,hanzi6);
  lcd_print_hz16(2,64,hanzi7);
  lcd_print_hz16(2,80,hanzi8);
  while(1);
 }